unit sSplash;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  T_Splash = class(TForm)
    ShowTimer: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure ShowTimerTimer(Sender: TObject);
  private
    procedure CreateRegion(vStr, vAddStr: string);
  public
    procedure SplashInfo(vStr, vAddStr: string; vInterval: Integer);
    procedure CreateParams(var Params :TCreateParams); override;    
  end;

implementation

{$R *.DFM}

procedure T_Splash.FormCreate(Sender: TObject);
begin
  Top := 0;
  Left := 0;
  Width := Screen.Width;
  Height := 75;
end;

procedure T_Splash.SplashInfo(vStr, vAddStr: string; vInterval: Integer);
begin
  ShowTimer.Enabled := False;
  CreateRegion(vStr, vAddStr);
  ShowTimer.Interval := vInterval;
  Visible := True;
  ShowTimer.Enabled := True;
end;

procedure T_Splash.ShowTimerTimer(Sender: TObject);
begin
  ShowTimer.Enabled := False;
  Visible := False;
end;

procedure T_Splash.CreateRegion(vStr, vAddStr: string);
const Offs = 10;
var bm: TBitmap;
  P1, P2: TPoint;
  HRgn: THandle;
begin
  bm := TBitmap.Create;
  bm.Height := Height;
  bm.Width := Screen.Width;

  BeginPath(bm.Canvas.Handle);

  bm.Canvas.Font.Name := 'Tahoma';
  bm.Canvas.Font.Size := 26;
  bm.Canvas.Font.Style := [fsBold];
  P1.x := Offs;
  P1.y := Offs;
  P2.x := bm.Width - bm.Canvas.TextWidth(vAddStr) - Offs;
  P2.y := Offs;
  bm.Canvas.Brush.Style := bsClear;
  if vStr <> '' then bm.Canvas.TextOut(P1.x, P1.y, vStr);
  if vAddStr <> '' then bm.Canvas.TextOut(P2.x, P2.y, vAddStr);

  EndPath(bm.Canvas.Handle);

  HRgn := PathToRegion(bm.Canvas.Handle);
  SetWindowRgn(Handle, HRgn, true);

  DeleteObject(HRgn);
  bm.Free;
end;

procedure T_Splash.CreateParams(var Params :TCreateParams);
begin
  inherited CreateParams(Params);
  Params.ExStyle := Params.ExStyle or WS_EX_TOOLWINDOW;
end;

end.

