unit sMAPIFunc;

interface

uses AMixer, Math, Windows, SysUtils, Messages;

type TMouseClickAct = (mcaLeftClick, mcaRightClick, mcaLeftDblClick, mcaRightDblClick, mcaLeftRightClick);

  //     vChannel   vInc.    0  65535
  //     
function SetVolume(vChannel: Integer; vInc: Integer): Integer;
//  -      
function Mute: string;
//  
function ShutDown: string;
//     BSPlayer
function BSPlayer_ChangePos(Delta: Integer): string;
// BSPlayer - -
function BSPlayer_PlayPause: string;
//     
function MouseMoveDelta(DeltaXY: Integer): string;
//     X, Y
function MouseSetPos(XY: LongInt): string;
//   
function MouseClickAct(aAct: TMouseClickAct): string;
//     
function KeyPressAct(vKey: Integer): string;
// WinAMP - -
function WinAMP_PlayPause: string;


implementation

function WinAMP_PlayPause: string;
var st: Integer;
  Wnd: HWND;
begin
  Wnd := FindWindow('Winamp v1.x', nil);
  st := SendMessage(Wnd, WM_USER, 0, 104);
  // 1 = playing, 3 = paused else stopped
  case st of
    1: begin
        SendMessage(Wnd, WM_COMMAND, 40046, 0);
        Result := '';
      end;
    3: begin
        SendMessage(Wnd, WM_COMMAND, 40046, 0);
        Result := ' ';
      end;
  else begin
      SendMessage(Wnd, WM_COMMAND, 40045, 0);
      Result := '';
    end;
  end;
end;

function KeyPressAct(vKey: Integer): string;
var h: HWND;
begin
  h := GetForegroundWindow;
  SendMessage(h, WM_KEYDOWN, vKey, 0);
  SendMessage(h, WM_KEYUP, vKey, 0);
end;

function MouseClickAct(aAct: TMouseClickAct): string;
begin
  case aAct of
    mcaLeftClick: begin
        mouse_event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
        mouse_event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
      end;
    mcaRightClick: begin
        mouse_event(MOUSEEVENTF_RIGHTDOWN, 0, 0, 0, 0);
        mouse_event(MOUSEEVENTF_RIGHTUP, 0, 0, 0, 0);
      end;
    mcaLeftDblClick: begin
        MouseClickAct(mcaLeftClick);
        GetDoubleClickTime;
        MouseClickAct(mcaLeftClick);
      end;
    mcaRightDblClick: begin
        MouseClickAct(mcaRightClick);
        GetDoubleClickTime;
        MouseClickAct(mcaRightClick);
      end;
    mcaLeftRightClick: begin
        mouse_event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
        mouse_event(MOUSEEVENTF_RIGHTDOWN, 0, 0, 0, 0);
        mouse_event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
        mouse_event(MOUSEEVENTF_RIGHTUP, 0, 0, 0, 0);
      end;
  end;
end;

function MouseMoveDelta(DeltaXY: Integer): string;
var p: TPoint;
  DeltaX, DeltaY: Integer;
begin
  DeltaX := LoWord(DeltaXY);
  DeltaY := HiWord(DeltaXY);
  if GetCursorPos(p) then
  begin
    MouseSetPos((p.x + DeltaX) + (p.y + DeltaY) * 256 * 256);
  end;
  Result := '';
end;

function MouseSetPos(XY: LongInt): string;
var X, Y: Integer;
begin
  X := LoWord(XY);
  Y := HiWord(XY);
  SetCursorPos(X, Y);
  Result := '';
end;

function BSPlayer_PlayPause: string;
var st: Integer;
  Wnd: HWND;
begin
  Wnd := FindWindow('BSPlayer', nil);
  st := SendMessage(Wnd, WM_USER + 2, $10102, 0);
  // 0 - STOP
  // 1 - PAUSE
  // 2 - PLAY
  case st of
    0: begin
        SendMessage(Wnd, WM_USER + 2, 20, 0);
        Result := '';
      end;
    1: begin
        SendMessage(Wnd, WM_USER + 2, 21, 0);
        Result := ' ';
      end;
    2: begin
        SendMessage(Wnd, WM_USER + 2, 21, 0);
        Result := '';
      end;
  end;
end;

function BSPlayer_ChangePos(Delta: Integer): string;
var move_len, move_pos: Integer;
  Wnd: HWND;
begin //Delta  
  Wnd := FindWindow('BSPlayer', nil);
  move_len := SendMessage(Wnd, WM_USER + 2, $10100, 0);
  move_pos := SendMessage(Wnd, WM_USER + 2, $10101, 0);
  move_pos := move_pos + Delta;
  move_pos := min(move_pos, move_len);
  move_pos := max(move_pos, 0);
  SendMessage(Wnd, WM_USER + 2, $10103, move_pos);
  //   SendMessage(Wnd, WM_USER + 2, BSP_Forw, 0);
  if Delta > 0 then
    if Delta < 60000
      then Result := '  ' + FloatToStr(Delta / 1000) + ' '
    else Result := '  ' + FloatToStr(Delta / 60000) + ' '
  else
    if Delta < 60000
      then Result := '  ' + FloatToStr(Delta / 1000) + ' '
    else Result := '  ' + FloatToStr(Delta / 60000) + ' ';
end;



function ShutDown;
var ph: THandle;
  tp, prevst: TTokenPrivileges;
  rl: DWORD;
begin
  OpenProcessToken(GetCurrentProcess, TOKEN_ADJUST_PRIVILEGES or TOKEN_QUERY, ph);
  LookupPrivilegeValue(nil, 'SeShutdownPrivilege', tp.Privileges[0].Luid);
  tp.PrivilegeCount := 1;
  tp.Privileges[0].Attributes := 2;
  AdjustTokenPrivileges(ph, FALSE, tp, SizeOf(prevst), prevst, rl);
  ExitWindowsEx(EWX_POWEROFF, 1);
  Result := ' ';
end;

function SetVolume(vChannel: Integer; vInc: Integer): Integer;
var Mixer: TAudioMixer;
  L, R, M: Integer;
  VD, MD: Boolean;
  Stereo: Boolean;
  IsSelect: Boolean;
  ProcentVol: Integer;
begin
  Mixer := TAudioMixer.Create(nil);
  try
    Mixer.GetVolume(0, vChannel, L, R, M, Stereo, VD, MD, IsSelect);
    L := L + vInc;
    R := R + vInc;
    L := min(L, maxWord);
    R := min(R, maxWord);
    L := max(L, 0);
    R := max(R, 0);
    Mixer.SetVolume(0, vChannel, L, R, M);
    ProcentVol := Round((L + R) / 2 / 65535 * 100);
    Result := ProcentVol; //'  ' + IntToStr(vChannel) + ': ' + IntToStr(ProcentVol) + ' %';
  finally
    Mixer.Free;
  end;
end;

function Mute: string;
var Mixer: TAudioMixer;
  L, R, M: Integer;
  VD, MD: Boolean;
  Stereo: Boolean;
  IsSelect: Boolean;
begin
  Mixer := TAudioMixer.Create(nil);
  try
    Mixer.GetVolume(0, -1, L, R, M, Stereo, VD, MD, IsSelect);
    Mixer.SetVolume(0, -1, L, R, 1 - M);
    if M = 0
      then Result := ' '
    else Result := ' ';
  finally
    Mixer.Free;
  end;
end;



end.

