unit sOptionsDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  sBaseDlgClass, Buttons, ExtCtrls, StdCtrls, Spin, ComCtrls, Mask,
  ToolEdit, ShellAPI;

type
  TSetupProc = procedure;

  T_OptionsDlg = class(TBaseDlgClass)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    spProcVolume: TSpinEdit;
    tbProcVolume: TTrackBar;
    lblProcVolume: TLabel;
    GroupBox6: TGroupBox;
    Label2: TLabel;
    spInterval: TSpinEdit;
    Label3: TLabel;
    spSplashTime: TSpinEdit;
    cbShowSplashMsg: TCheckBox;
    btnHomePage: TSpeedButton;
    GroupBox2: TGroupBox;
    lbModules: TListBox;
    btnModuleSetup: TSpeedButton;
    GroupBox3: TGroupBox;
    lblComment: TLabel;
    procedure spProcVolumeChange(Sender: TObject);
    procedure tbProcVolumeChange(Sender: TObject);
    procedure btnHomePageClick(Sender: TObject);
    procedure btnModuleSetupClick(Sender: TObject);
    procedure lbModulesClick(Sender: TObject);
    procedure lbModulesKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    procedure CalcProc;
    procedure GetModuleComment;
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}

procedure T_OptionsDlg.CalcProc;
begin
  lblProcVolume.Caption :=
    FormatFloat('0', (spProcVolume.Value / MAXWORD) * 100) + ' %';
end;

procedure T_OptionsDlg.spProcVolumeChange(Sender: TObject);
begin
  if spProcVolume.Value <> tbProcVolume.Position
    then tbProcVolume.Position := spProcVolume.Value;
  CalcProc;
end;

procedure T_OptionsDlg.tbProcVolumeChange(Sender: TObject);
begin
  if spProcVolume.Value <> tbProcVolume.Position
    then spProcVolume.Value := tbProcVolume.Position;
  CalcProc;
end;

procedure T_OptionsDlg.btnHomePageClick(Sender: TObject);
begin
  ShellExecute(GetDesktopWindow, 'open', 'http://rtelsignal.narod.ru', '', '', SW_SHOWMAXIMIZED);
end;

procedure T_OptionsDlg.btnModuleSetupClick(Sender: TObject);
var libh: THandle;
  SetupProc: TSetupProc;
begin
  if lbModules.ItemIndex < 0 then
  begin
    MessageBox(Application.Handle, '   ', '', MB_OK);
    Exit;
  end;
  libh := GetModuleHandle(PChar(lbModules.Items[lbModules.ItemIndex]));
  if libh = 0 then
  begin
    MessageBox(Application.Handle, '   !', '', MB_OK);
    Exit;
  end;
  SetupProc := GetProcAddress(libh, 'Setup');
  if @SetupProc = nil then
  begin
    MessageBox(Application.Handle, '     Setup,      ',
      '', MB_OK);
    Exit;
  end;
  SetupProc;
end;

procedure T_OptionsDlg.lbModulesClick(Sender: TObject);
begin
  GetModuleComment;
end;

procedure T_OptionsDlg.GetModuleComment;
begin
  if lbModules.Items[lbModules.ItemIndex] = 'Remote.dll' then
  begin
    lblComment.Caption := '    c ';
    Exit;
  end;
  if lbModules.Items[lbModules.ItemIndex] = 'OSDText.dll' then
  begin
    lblComment.Caption := '      ';
    Exit;
  end;
  if lbModules.Items[lbModules.ItemIndex] = 'OSDVolume.dll' then
  begin
    lblComment.Caption := '       ';
      Exit;
  end;
  if lbModules.Items[lbModules.ItemIndex] = 'UserProc.dll' then
  begin
    lblComment.Caption := '    ' + #13 +
      '    ';
    Exit;
  end;
end;

procedure T_OptionsDlg.lbModulesKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  GetModuleComment;
end;

end.

