unit sRemAppListDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  sBaseDlgClass, Buttons, ExtCtrls, dxCntner, dxTL, StdCtrls,
  ComCtrls, ToolWin, ActnList, ImgList, Mask, ToolEdit, dxTLClms,
  sSelectAppDlg, contnrs, StrUtils, sSelectMsgDlg, dxDBCtrl, dxDBGrid,
  OleServer, Excel97;

type
  TMsgDescr = class
    Msg: Integer;
    Descr: string;
  end;

  T_RemAppListDlg = class(TBaseDlgClass)
    Panel2: TPanel;
    gMsg: TdxTreeList;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    cAppSelect: TComboBox;
    ToolButton4: TToolButton;
    ImageList1: TImageList;
    ActionList1: TActionList;
    AcDel: TAction;
    AcNew: TAction;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    cFilePathName: TFilenameEdit;
    Label2: TLabel;
    cParamExec: TEdit;
    Label3: TLabel;
    cClassName: TEdit;
    Label4: TLabel;
    cWindowName: TEdit;
    SpeedButton1: TSpeedButton;
    AcSave: TAction;
    gMsgKeyCode: TdxTreeListMaskColumn;
    gMsgKeyDescr: TdxTreeListMaskColumn;
    gMsgLParam: TdxTreeListButtonColumn;
    gMsgMsg: TdxTreeListButtonColumn;
    gMsgWParam: TdxTreeListButtonColumn;
    gMsgMsgApp: TdxTreeListButtonColumn;
    gMsgRept: TdxTreeListSpinColumn;
    gMsgComment: TdxTreeListMaskColumn;
    AcExcel: TAction;
    AcCopy: TAction;
    AcPaste: TAction;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    AcEmpty: TAction;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    ExcelApp: TExcelApplication;
    ToolButton12: TToolButton;
    ToolButton13: TToolButton;
    procedure cFilePathNameAfterDialog(Sender: TObject; var Name: string;
      var Action: Boolean);
    procedure gMsgCustomDrawCell(Sender: TObject; ACanvas: TCanvas;
      ARect: TRect; ANode: TdxTreeListNode; AColumn: TdxTreeListColumn;
      ASelected, AFocused, ANewItemRow: Boolean; var AText: string;
      var AColor: TColor; AFont: TFont; var AAlignment: TAlignment;
      var ADone: Boolean);
    procedure gMsgMsgAppButtonClick(Sender: TObject;
      AbsoluteIndex: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure gMsgWParamButtonClick(Sender: TObject;
      AbsoluteIndex: Integer);
    procedure AcEmptyExecute(Sender: TObject);
    procedure AcCopyExecute(Sender: TObject);
    procedure AcPasteExecute(Sender: TObject);
    procedure AcExcelExecute(Sender: TObject);
  private
    FBuffer: array[2..13] of string;
    procedure ReadIniFile(vList: TObjectList; vFileName: string);
    procedure AssignDescrValues(vList: TObjectList; vCBox: TComboBox);
  public
    MsgDescList: TObjectList;
    WParamDescList: TObjectList;
  end;

implementation


{$R *.DFM}

{ T_RemAppListDlg }


procedure T_RemAppListDlg.cFilePathNameAfterDialog(Sender: TObject;
  var Name: string; var Action: Boolean);
var vExe: string;
begin
  vExe := AnsiUpperCase(ChangeFileExt(ExtractFileName(Name), ''));
  if vExe = 'RTELSIGNAL2' then
  begin
    cClassName.Text := 'T_RSignalMAPI';
    cWindowName.Text := '';
    Exit;
  end;
  if (Pos('WINAMP', vExe) > 0)
    or (vExe = 'APOLLO')
    or (vExe = 'FOOBAR2000')
    then
  begin
    cClassName.Text := 'Winamp v1.x';
    cWindowName.Text := '';
    Exit;
  end;
  if Pos('BSPLAY', vExe) > 0 then
  begin
    cClassName.Text := 'BSPlayer';
    cWindowName.Text := '';
    Exit;
  end;
  if vExe = 'I_VIEW32' then
  begin
    cClassName.Text := 'IrfanView';
    cWindowName.Text := '';
    Exit;
  end;
  if vExe = 'FLY2000TV' then
  begin
    cClassName.Text := 'TMain';
    cWindowName.Text := 'ZolotarevFly2000TV';
    Exit;
  end;
end;

procedure T_RemAppListDlg.gMsgCustomDrawCell(Sender: TObject;
  ACanvas: TCanvas; ARect: TRect; ANode: TdxTreeListNode;
  AColumn: TdxTreeListColumn; ASelected, AFocused, ANewItemRow: Boolean;
  var AText: string; var AColor: TColor; AFont: TFont;
  var AAlignment: TAlignment; var ADone: Boolean);
begin
  if ((AColumn.Name = 'gMsgMsg') or (AColumn.Name = 'gMsgWParam') or (AColumn.Name = 'gMsgLParam'))
    and ((ANode.Values[AColumn.Index] = '') or (ANode.Values[AColumn.Index] = 0))
    then AFont.Color := clWhite;
end;

procedure T_RemAppListDlg.gMsgMsgAppButtonClick(Sender: TObject;
  AbsoluteIndex: Integer);
var SelAppDlg: T_SelectAppDlg;
begin
  SelAppDlg := T_SelectAppDlg.Create(Self);
  SelAppDlg.cAppListBox.Items.AddStrings(cAppSelect.Items);
  if (SelAppDlg.ShowModal = mrOK)
    and (SelAppDlg.cAppListBox.ItemIndex >= 0) then
  begin
    gMsg.FocusedNode.Strings[gMsgMsgApp.Index] :=
      SelAppDlg.cAppListBox.Items[SelAppDlg.cAppListBox.ItemIndex];
    SendMessage(gMsg.Handle, WM_KEYDOWN, VK_ESCAPE, 0);
  end;
  SelAppDlg.Free;
end;

procedure T_RemAppListDlg.FormCreate(Sender: TObject);
begin
  inherited;
  MsgDescList := TObjectList.Create(True);
  WParamDescList := TObjectList.Create(True);
  ReadIniFile(MsgDescList, ExtractFilePath(Application.ExeName) + 'messages.ini');
  ReadIniFile(WParamDescList, ExtractFilePath(Application.ExeName) + 'wparam.ini');
end;

procedure T_RemAppListDlg.AssignDescrValues(vList: TObjectList; vCBox: TComboBox);
var i: Integer;
begin
  vCBox.Items.Clear;
  for i := 0 to vList.Count - 1 do
    vCBox.Items.Add(TMsgDescr(vList.Items[i]).Descr);
end;

procedure T_RemAppListDlg.ReadIniFile(vList: TObjectList; vFileName: string);
var Desc: TStringList;
  i: Integer;
  vStr: string;
  p: Integer;
  ms: TMsgDescr;
begin
  Desc := TStringList.Create;
  Desc.LoadFromFile(vFileName);
  for i := 0 to Desc.Count - 1 do
  begin
    vStr := Desc[i];
    p := pos('=', vStr);
    if p > 0 then
    begin
      ms := TMsgDescr.Create;
      ms.Descr := Copy(vStr, 1, p - 1);
      Delete(vStr, 1, p);
      if length(vStr) > 0 then
      begin
        if vStr[1] = '$' then
        begin
          Delete(vStr, 1, 1);
          if length(vStr) > 0 then
          try ms.Msg := Hex2Dec(vStr); except end;
        end
        else try ms.Msg := StrToInt(vStr); except end;
      end;
      vList.Add(ms);
    end;
  end;
  Desc.Free;
end;

procedure T_RemAppListDlg.FormDestroy(Sender: TObject);
begin
  MsgDescList.Clear;
  MsgDescList.Free;
  WParamDescList.Clear;
  WParamDescList.Free;
  inherited;
end;

procedure T_RemAppListDlg.gMsgWParamButtonClick(Sender: TObject;
  AbsoluteIndex: Integer);
var SelMsgDlg: T_SelectMsgDlg;
begin
  SelMsgDlg := T_SelectMsgDlg.Create(Self);
  AssignDescrValues(MsgDescList, SelMsgDlg.cMsgList);
  AssignDescrValues(WParamDescList, SelMsgDlg.cWParamList);
  if gMsg.FocusedNode.Values[gMsgMsg.Index] <> ''
    then SelMsgDlg.cMsg.Text := gMsg.FocusedNode.Values[gMsgMsg.Index];
  if gMsg.FocusedNode.Values[gMsgWParam.Index] <> ''
    then SelMsgDlg.cWParam.Text := gMsg.FocusedNode.Values[gMsgWParam.Index];
  if gMsg.FocusedNode.Values[gMsgLParam.Index] <> ''
    then SelMsgDlg.cLParam.Text := gMsg.FocusedNode.Values[gMsgLParam.Index];

  if SelMsgDlg.ShowModal = mrOK then
  begin
    gMsg.FocusedNode.Values[gMsgMsg.Index] := SelMsgDlg.cMsg.Text;
    gMsg.FocusedNode.Values[gMsgWParam.Index] := SelMsgDlg.cWParam.Text;
    gMsg.FocusedNode.Values[gMsgLParam.Index] := SelMsgDlg.cLParam.Text;
    SendMessage(gMsg.Handle, WM_KEYDOWN, VK_ESCAPE, 0);
  end;
  SelMsgDlg.Free;
end;

procedure T_RemAppListDlg.AcEmptyExecute(Sender: TObject);
var i: Integer;
begin
  if MessageDlg('  ?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
  begin
    for i := 2 to gMsg.ColumnCount - 1 do gMsg.FocusedNode.Strings[i] := '';
    SendMessage(gMsg.Handle, WM_KEYDOWN, VK_ESCAPE, 0);
  end;
end;

procedure T_RemAppListDlg.AcCopyExecute(Sender: TObject);
var i: Integer;
begin
  for i := 2 to gMsg.ColumnCount - 1 do
    FBuffer[i] := gMsg.FocusedNode.Strings[i];
  AcPaste.Enabled := true;
end;

procedure T_RemAppListDlg.AcPasteExecute(Sender: TObject);
var i: Integer;
begin
  for i := 2 to gMsg.ColumnCount - 1 do
    gMsg.FocusedNode.Strings[i] := FBuffer[i];
  SendMessage(gMsg.Handle, WM_KEYDOWN, VK_ESCAPE, 0);
  gMsg.Repaint;
end;

procedure T_RemAppListDlg.AcExcelExecute(Sender: TObject);
var TabGrid: Variant;
  R, C: Integer;
  cR, cC: Integer;
  WorkSheet: _WorkSheet;
  Ind: OLEVariant;
begin
  R := gMsg.Count + 1;
  C := gMsg.ColumnCount;
  TabGrid := VarArrayCreate([0, (R - 1), 0, (C - 1)], VarOleStr);
  for cC := 0 to C - 1 do
    TabGrid[0, cC] := gMsg.Columns[cC].Caption;
  for cR := 0 to R - 2 do
    for cC := 0 to C - 1 do
      TabGrid[cR + 1, cC] := gMsg.Items[cR].Strings[cC];

  ExcelApp.Connect;
  ExcelApp.Visible[0] := true;
  ExcelApp.Workbooks.Add(NULL, 0);
  WorkSheet := (ExcelApp.ActiveSheet as _WorkSheet);
  WorkSheet.Name := cAppSelect.Text;
  Worksheet.Range['A1', Worksheet.Cells.Item[R, C]].Value := TabGrid;
  Worksheet.Range['A1', Worksheet.Cells.Item[1, C]].HorizontalAlignment := xlCenter;
  Worksheet.Range['A1', Worksheet.Cells.Item[1, C]].Interior.ColorIndex := 6;
  Worksheet.Range['A1', Worksheet.Cells.Item[1, C]].Borders.LineStyle := xlContinuous;
  WorkSheet.Columns.AutoFit;
  ExcelApp.Disconnect;
  TabGrid := Unassigned;
end;

end.

