unit sSelectMsgDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  sBaseDlgClass, Buttons, ExtCtrls, StdCtrls, Spin, StrUtils;

type
  T_SelectMsgDlg = class(TBaseDlgClass)
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    cMsgList: TComboBox;
    Label1: TLabel;
    cMsg: TSpinEdit;
    Label4: TLabel;
    Label2: TLabel;
    cWParam: TSpinEdit;
    Label3: TLabel;
    cWParamList: TComboBox;
    Label5: TLabel;
    Label6: TLabel;
    cMsgHex: TEdit;
    cWParamHex: TEdit;
    Label7: TLabel;
    cLParam: TSpinEdit;
    Label8: TLabel;
    cLParamHex: TEdit;
    Label9: TLabel;
    cLo: TSpinEdit;
    cHi: TSpinEdit;
    Label10: TLabel;
    procedure cMsgListChange(Sender: TObject);
    procedure cWParamListChange(Sender: TObject);
    procedure cMsgChange(Sender: TObject);
    procedure cWParamChange(Sender: TObject);
    procedure cLParamChange(Sender: TObject);
    procedure cMsgHexChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cLoChange(Sender: TObject);
  private
    procedure SetHexValue(vVal: Integer; vEd: TEdit);
    procedure SetDecValue(vHex: string; vEd: TEdit);
    { Private declarations }
  public
    { Public declarations }
  end;

implementation

uses sRemAppListDlg;

{$R *.DFM}

procedure T_SelectMsgDlg.cMsgListChange(Sender: TObject);
begin
  cMsg.Value :=
    TMsgDescr(T_RemAppListDlg(Owner).MsgDescList.Items[cMsgList.ItemIndex]).Msg;
end;

procedure T_SelectMsgDlg.cWParamListChange(Sender: TObject);
begin
  cWParam.Value :=
    TMsgDescr(T_RemAppListDlg(Owner).WParamDescList.Items[cWParamList.ItemIndex]).Msg;
end;

procedure T_SelectMsgDlg.cMsgChange(Sender: TObject);
begin
  SetHexValue(cMsg.Value, cMsgHex);
end;

procedure T_SelectMsgDlg.cWParamChange(Sender: TObject);
begin
  SetHexValue(cWParam.Value, cWParamHex);
end;

procedure T_SelectMsgDlg.cLParamChange(Sender: TObject);
begin
  SetHexValue(cLParam.Value, cLParamHex);
end;

procedure T_SelectMsgDlg.SetHexValue(vVal: Integer; vEd: TEdit);
var HexStr: string;
begin
  try
    HexStr := Dec2Hex(vVal, 1);
    if HexStr <> vEd.Text then vEd.Text := HexStr;
  except
  end;
end;

procedure T_SelectMsgDlg.SetDecValue(vHex: string; vEd: TEdit);
var vSEd: TSpinEdit;
  vVl: Integer;
begin
  vSed := nil;
  if vEd.Name = 'cMsgHex' then vSEd := cMsg;
  if vEd.Name = 'cWParamHex' then vSEd := cWParam;
  if vEd.Name = 'cLParamHex' then vSEd := cLParam;
  if vSed = nil then Exit;
  try
    vVl := Hex2Dec(vEd.Text);
    if vVl <> vSEd.Value then vSEd.Value := vVl;
  except
  end;
end;

procedure T_SelectMsgDlg.cMsgHexChange(Sender: TObject);
var i: Integer;
  vStr: string;
begin
  vStr := TEdit(Sender).Text;
  for i := Length(vStr) downto 1 do
    if not (vStr[i] in ['0'..'9', 'A', 'B', 'C', 'D', 'E', 'F'])
      then Delete(vStr, i, 1);
  if vStr <> TEdit(Sender).Text then
  begin
    TEdit(Sender).Text := vStr;
    SendMessage(TEdit(Sender).Handle, WM_KEYDOWN, VK_END, 0);
  end;
  SetDecValue(vStr, TEdit(Sender));
end;

procedure T_SelectMsgDlg.FormCreate(Sender: TObject);
begin
  inherited;
  //
end;

procedure T_SelectMsgDlg.cLoChange(Sender: TObject);
var NewValue: Integer;
begin
  NewValue := cHi.Value * 256 * 256 + cLo.Value;
  if cLParam.Value <> NewValue then cLParam.Value := NewValue;
end;

end.

